// To compile, perform:
// gcc -std=c99 randomQuickSort.c -o randomQUickSort
// Run
// ./randomQuickSort

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <sys/time.h>
#include <string.h>

int partition(int* target, int left, int right) {
    // Select a number between left and right at random.
    int random = left + rand() % (right - left + 1);
    // Exchange target[right] and target[random].
    int tmp = target[right]; target[right] = target[random]; target[random] = tmp;
    int pivot = target[right];
    int i = left-1; // i scans the array from the left.
    int j = right;  // j scans the array from the right.
    for (;;) {
        // Move from the left until hitting a value no less than the pivot.
        for(i++; target[i] < pivot; i++){}
        // Move from the right until hitting a value no greater than the pivot.
        for(j--; pivot < target[j] && i < j; j--){}
        if (i >= j)  break;
        // Exchange target[i] and target[j].
        tmp = target[i];  target[i] = target[j];  target[j] = tmp;
    }
    // Exchange target[i] and target[right].
    tmp = target[i];  target[i] = target[right];  target[right] = tmp;
    return i;
}

void randomQuickSort1(int* target, int left, int right ) {
    if (left < right) {
        int i = partition(target, left, right); // i: Position of the pivot.
        randomQuickSort1(target, left, i - 1);
        randomQuickSort1(target, i + 1, right);
    }
}

void randomQuickSort2(int* target, int aLeft, int right) {
    int left = aLeft;
    while (left < right) {
        int i = partition(target, left, right);
        randomQuickSort2(target, left, i-1);
        left = i+1;
    }
}

void randomQuickSort3(int* target, int aLeft, int aRight) {
    int left = aLeft; int right = aRight;
    while (left < right) {
        int i = partition(target, left, right);
        if( i - left <= right - i ){ // The left interval is shorter.
            randomQuickSort3(target, left, i-1);
            left=i+1;
        }else{                       // The right interval is shorter.
            randomQuickSort3(target, i+1, right);
            right=i-1;
        }
    }
}

int main(int argc, char *argv[])
{
    // The stack is used.
    int target[12] = {48, 195, 12, 49, 198, 24, 99, 140, 48, 195, 12, 48};
    
    printf("Input\t");
    for(int i=0; i<12; i++){ printf("%i ", target[i]); }
    printf("\n");
    
    randomQuickSort1(target, 0, 11);    // The 0-origin index is used.
    
    printf("Output\t");
    for(int i=0; i<12; i++){ printf("%i ", target[i]); }
    printf("\n");
    
    return EXIT_SUCCESS;
}
